/****************************************************************************************
 **     Autor:          [HLB]Jabberwocky
 **     Version:        1.6
 **     Datum:          07.02.2003
 **     Info:           Dieses Plugin basiert auf den untengenannten
 **                     Plugins. Daher gilt mein besonderer Dank den
 **                     entsprechenden Autoren, die mir die Erstellung
 **                     dieses Plugins erst ermglicht haben.
 **                     1. plugin_logd_roundcounter
 **                     2. plugin_logd_lastscout
 **                     3. plugin_announce_attacks
 **                     4. plugin_logd_killstreak
 **                     5. plugin_logd_impressive
 **                     6. plugin_logd_playeraward
 **                     n. ...
 **     Funktionalitt: * Austausch des Mapcycle
 **                     * Rckrunde auf derselben Map
 **                     * Anzeige des Rundenstandes
 **                     * Akustische Anzeige fr den letzten berlebenden aus einem Team
 **                     * Akustische Anzeige beim Teamattack bzw. Teamkill
 **                     * Akustische Anzeige einer "Kill"-Serie
 **                     * Akustische Anzeige eines Headshots
 **                     * Anzeige des Rundenbesten
 ****************************************************************************************/

#pragma dynamic 16384

/********************
 * Include-Strecken *
 ********************/
#include <core> 
#include <console> 
#include <string> 
#include <admin> 
#include <adminlib>

/**************
 * Konstanten *
 **************/
// Admin-Berechtigungsgrad
#define ACCESS_CONSOLE 131072
#define ACCESS_MAPCYCLE 1
#define ACCESS_RUECKRUNDE 1
#define ACCESS_ROUNDCOUNT 1
#define ACCESS_LASTSCOUT 1
#define ACCESS_ANNOUNCE 1
#define ACCESS_KILLSTREAK 1
#define ACCESS_HEADSHOT 1
#define ACCESS_BESTPLAYER 1
// Allgemeine
#define JA 1
#define NEIN 0
#define ANZEIGE_DAUER 5
#define BEIDE_TEAMS 0
#define TEAM_TERROR 1
#define TEAM_COUNTER 2
#define LAST_MAN 1
#define CLEAN_SLATE 0
#define LEBEND 1
#define DAMAGE36 36
#define DAMAGE40 40
#define DAMAGE45 45
#define DAMAGE50 50
#define DAMAGE70 70
#define DAMAGE80 80
#define DAMAGE95 95
#define DAMAGE155 155
#define DAMAGE200 200

/*********************
 * Globale Variablen *
 *********************/
new STRING_VERSION[MAX_DATA_LENGTH] = "2.50.0";
new SERVERFILE[MAX_NAME_LENGTH] = "server.cfg";
new MAPSINI[MAX_NAME_LENGTH] = "maps.ini";
new ZUFALLSZEILE[MAX_TEXT_LENGTH];
new GESUCHTEZEILE[MAX_TEXT_LENGTH];
new LEER[MAX_TEXT_LENGTH] = "LEER";
new ANZAHLPLAYER = 0;

// Fr den Mapcyclewechsel
new MAPCYCLEFILE[MAX_NAME_LENGTH] = "mapcycle.txt";
new MAPCYCLE_INIT[MAX_NAME_LENGTH] = "mapcycle_init.txt";
new MAPCYCLE_AUSWAHL[MAX_NAME_LENGTH] = "mapcycle_auswahl.txt";
new MAPCYCLE_SOURCE[MAX_NAME_LENGTH] = "mapcycle_source.txt";
new MAPS_GESPIELT[MAX_NAME_LENGTH] = "maps_gespielt.txt";
new MAPCYCLE_TEMP[MAX_NAME_LENGTH] = "mapcycle_temp.txt";

// Fr den (Rckrunden-)Mapwechsel
new bRueckrunde = true;
new cRueckrundeStandard[0] = '1';

// Fr die Anzeige des Rundenstatus
new bRoundCounter = true;
new cRundenZaehlerStandard[0] = '1';
new sCtScore [MAX_DATA_LENGTH];                                                                       
new sTerrScore[MAX_DATA_LENGTH];
new iRound;

// Fr die Benachrichtigung des LastScout
new bLastScout = true;
new bLastScout_Informiert = false;
new bLastScout_Informiert_T = false;
new bLastScout_Informiert_CT = false;
new cLastScoutStandard[0] = '1';
new LASTSCOUT_TEXTE[MAX_NAME_LENGTH] = "lastscout_texte.txt";
new LASTSCOUT_SPRUECHE[MAX_NAME_LENGTH] = "lastscout_sprueche.txt";
new LASTSCOUT_WIN_SPRUECHE[MAX_NAME_LENGTH] = "lastscout_win_sprueche.txt";

// Fr die Benachrichtung bei Teamattacks und Teamkills
new bAnnounce = true;
new cAnnounceStandard[0] = '1';
new KILL_SPRUECHE[MAX_NAME_LENGTH] = "kill_sprueche.txt";

// Fr die Benachrichtung bei Killstreaks
new bKillStreak = true;
new cKillStreakStandard[0] = '1';
new KillCount[MAX_PLAYERS] = {CLEAN_SLATE,...};
new KILLSTREAK_SPRUECHE[MAX_NAME_LENGTH] = "killstreak_sprueche.txt";

// Fr die Benachrichtung bei Headshots
new bHeadShot = true;
new cHeadShotStandard[0] = '1';
new HeadCount[MAX_PLAYERS] = {CLEAN_SLATE,...};
new HEADSHOT_SPRUECHE[MAX_NAME_LENGTH] = "headshot_sprueche.txt";

// Fr die Benachrichtung des Rundenbesten
new bBestPlayer = true;
new cBestPlayerStandard[0] = '1';
new FragCount[MAX_PLAYERS] = {CLEAN_SLATE,...};
new Ranking[MAX_PLAYERS] = {CLEAN_SLATE,...};


/**************
 * Funktionen *
 **************/


/* Diese Funktion wird durch das LOGD-Commando "53" Player Suicide
 * aufgerufen.
 * Paramter Format: playerUserIndex weaponString
 * Examples: 2 grenade // person 2 suicides by grenade 
 */
public logd_suicide(HLCommand,HLData,HLUserName,UserIndex) {

  new Command[MAX_COMMAND_LENGTH];
  new Data[MAX_DATA_LENGTH];
  new UserName[MAX_NAME_LENGTH];
  new Text[MAX_TEXT_LENGTH];
  new Ergebnis = NEIN;
  
  /* Auslesen des LOGD-Commandos */
  convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // logd_disconnect
  convert_string(HLData,Data,MAX_DATA_LENGTH); // playerUserIndex weaponString
  convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins
  
  /* Prfen, ob der LastScout benachrichtigt werden mu */
  if (bLastScout) {
    Ergebnis = pruefe_LastScout();
    if (Ergebnis == JA) {
      bLastScout_Informiert = true;
    }
  } 
    
  return PLUGIN_HANDLED;
}

/* Diese Funktion wird durch das LOGD-Commando "57" Player Kill
 * aufgerufen.
 * Paramter Format: killerUserIndex victimUserIndex weaponString 
 * Examples: 20 21 aug // person 20 killed person 21 with the aug 
 */
public logd_kill(HLCommand,HLData,HLUserName,UserIndex) {

  new Command[MAX_COMMAND_LENGTH];
  new Data[MAX_DATA_LENGTH];
  new UserName[MAX_NAME_LENGTH];
  new KillerUserIndex[MAX_DATA_LENGTH];
  new iKillerUserIndex;
  new VictimUserIndex[MAX_DATA_LENGTH];
  new iVictimUserIndex;
  new KillerWeapon[MAX_DATA_LENGTH];
  new Text[MAX_TEXT_LENGTH];
  new Ergebnis = NEIN;
  
  /* Auslesen des LOGD-Commandos */
  convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // logd_disconnect
  convert_string(HLData,Data,MAX_DATA_LENGTH); // killerUserIndex victimUserIndex weaponString 
  convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins
  
  strsplit(Data," ",KillerUserIndex,MAX_DATA_LENGTH,VictimUserIndex,MAX_DATA_LENGTH,KillerWeapon,MAX_DATA_LENGTH);
  
  iKillerUserIndex = strtonum(KillerUserIndex);
  iVictimUserIndex = strtonum(VictimUserIndex);
  
  /* Prfen, ob es ein Team-Kill war */
  Ergebnis = pruefe_TeamKill(iKillerUserIndex, iVictimUserIndex);
  
  /* TeamKillAnnounce ausfhren */
  if (bAnnounce) {
    ausfuehren_TeamKillAnnounce(iKillerUserIndex,iVictimUserIndex,KillerWeapon,Ergebnis);
  }
  
  /* KillStreak ausfhren */
  if (bKillStreak) {
    ausfuehren_killstreak(iKillerUserIndex,iVictimUserIndex,Ergebnis);
  }
      
  /* Prfen, ob der LastScout benachrichtigt werden mu */
  if (bLastScout) {
    Ergebnis = pruefe_LastScout();
    if (Ergebnis == JA) {
      bLastScout_Informiert = true;
    }
  }
  
  return PLUGIN_HANDLED;
}

/* Diese Funktion wird durch das LOGD-Commando "58" Player Hurt
 * aufgerufen.
 * Paramter Format: attackerUserIndex victimUserIndex weaponString victimDamage victimDamageArmor victimHealth victimArmor 
 * Examples: 1 2 glock18 damage#5 damage_armor#0 health#95 armor#0 // person 1 hurt person 2 with the glock18
 */
public logd_hurt(HLCommand,HLData,HLUserName,UserIndex) {

  new Command[MAX_COMMAND_LENGTH];
  new Data[MAX_DATA_LENGTH];
  new UserName[MAX_NAME_LENGTH];
  new AttackerUserIndex[MAX_DATA_LENGTH];
  new iAttackerUserIndex;
  new VictimUserIndex[MAX_DATA_LENGTH];
  new iVictimUserIndex;
  new AttackerWeapon[MAX_DATA_LENGTH];
  new VictimRest[MAX_DATA_LENGTH];
  new VDamage[MAX_DATA_LENGTH];
  new VDamage_Armor[MAX_DATA_LENGTH];
  new VRest_Health[MAX_DATA_LENGTH];
  new VRest_Armor[MAX_DATA_LENGTH];
  new VictimDamage[MAX_DATA_LENGTH];
  new iVictimDamage;
  new VictimDamage_Armor[MAX_DATA_LENGTH];
  new VictimRest_Health[MAX_DATA_LENGTH];
  new iVictimRest_Health;
  new VictimRest_Armor[MAX_DATA_LENGTH];
  new Dummy[MAX_DATA_LENGTH];
  
  new Text[MAX_TEXT_LENGTH];
  new Ergebnis = NEIN;
  
  /* Auslesen des LOGD-Commandos */
  convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // logd_disconnect
  convert_string(HLData,Data,MAX_DATA_LENGTH); // attackerUserIndex victimUserIndex weaponString 
  convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins
  
  strsep(Data," ",AttackerUserIndex,MAX_DATA_LENGTH,VictimUserIndex,MAX_DATA_LENGTH,AttackerWeapon,MAX_DATA_LENGTH,VictimRest,MAX_DATA_LENGTH);
  
  strsplit(VictimRest," ",VDamage,MAX_DATA_LENGTH,VDamage_Armor,MAX_DATA_LENGTH,VRest_Health,MAX_DATA_LENGTH,VRest_Armor,MAX_DATA_LENGTH);
  
  strsplit(VDamage,"#",Dummy,MAX_DATA_LENGTH,VictimDamage,MAX_DATA_LENGTH);
  
  strsplit(VDamage_Armor,"#",Dummy,MAX_DATA_LENGTH,VictimDamage_Armor,MAX_DATA_LENGTH);
  
  strsplit(VRest_Health,"#",Dummy,MAX_DATA_LENGTH,VictimRest_Health,MAX_DATA_LENGTH);
  
  strsplit(VRest_Armor,"#",Dummy,MAX_DATA_LENGTH,VictimRest_Armor,MAX_DATA_LENGTH);
  
  iAttackerUserIndex = strtonum(AttackerUserIndex);
  iVictimUserIndex = strtonum(VictimUserIndex);
  iVictimDamage = strtonum(VictimDamage);
  iVictimRest_Health = strtonum(VictimRest_Health);
  
  /* Prfen, ob es ein Team-Attack war */
  Ergebnis = pruefe_TeamAttack(iAttackerUserIndex, iVictimUserIndex);
  
  /* TeamAttackAnnounce ausfhren */
  if (   (bAnnounce) 
      && (iAttackerUserIndex != iVictimUserIndex)) {
    ausfuehren_TeamAttackAnnounce(iAttackerUserIndex,iVictimUserIndex,AttackerWeapon,Ergebnis);
  }
  
  /* Prfen, ob es ein Headshot war */
  if (   (bHeadShot) 
      && (iAttackerUserIndex != iVictimUserIndex)) {
    Ergebnis = pruefe_HeadShot(iVictimDamage,iVictimRest_Health,AttackerWeapon,Ergebnis);
    
    /* Headshot */
    if (Ergebnis == JA) {
      ausfuehren_HeadShot(iAttackerUserIndex,AttackerWeapon);
    }
  }
    
  return PLUGIN_HANDLED;
}

/* Diese Funktion wird durch das LOGD-Commando "61" Team Action
 * aufgerufen.
 * Paramter Format: teamString actionString
 * Examples: Team "TERRORIST" triggered "Terrorists_Win" (CT "4") (T "6") => CT#4 T#6
 *           Team "CT" triggered "Target_Saved" (CT "1") (T "0")
 */
public logd_teamaction(HLCommand,HLData,HLUserName,UserIndex) {

  new Command[MAX_COMMAND_LENGTH];
  new Data[MAX_DATA_LENGTH];
  new UserName[MAX_NAME_LENGTH];
  new Text[MAX_TEXT_LENGTH];
  new Team[MAX_DATA_LENGTH];
  new TeamAction[MAX_DATA_LENGTH];
  new TeamCT[MAX_DATA_LENGTH];
  new TeamT[MAX_DATA_LENGTH];
  
  /* Auslesen des LOGD-Commandos */
  convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // logd_teamaction
  convert_string(HLData,Data,MAX_DATA_LENGTH); // teamString + actionString
  convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins
  
  /* Zuweisen der Parameter auf die jeweiligen Variablen */
  strsplit(Data," #",Team,MAX_DATA_LENGTH,TeamAction,MAX_DATA_LENGTH,TeamCT,MAX_DATA_LENGTH,sCtScore,MAX_DATA_LENGTH,TeamT,MAX_DATA_LENGTH,sTerrScore,MAX_DATA_LENGTH);
  
  if (bBestPlayer) {
    ausfuehren_Anzeige_BestPlayer();
  }
      
  return PLUGIN_HANDLED;
}

/* Diese Funktion wird durch das LOGD-Commando "62" World Action
 * aufgerufen.
 * Paramter Format: actionString
 * Examples: Round_Start = Rundenbeginn
 */
public logd_worldaction(HLCommand,HLData,HLUserName,UserIndex) {

  new Command[MAX_COMMAND_LENGTH];
  new Data[MAX_DATA_LENGTH];
  new UserName[MAX_NAME_LENGTH];
  new Text[MAX_TEXT_LENGTH];
  new WorldAction_1[MAX_DATA_LENGTH];
  new WorldAction_2[MAX_DATA_LENGTH];
  new iUserIndex;

  /* Auslesen des LOGD-Commandos */
  convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // logd_worldaction
  convert_string(HLData,Data,MAX_DATA_LENGTH); // actionString
  convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins

  /* Zuweisen der Parameter auf die jeweiligen Variablen */
  strsplit(Data," _",WorldAction_1,MAX_DATA_LENGTH,WorldAction_2,MAX_DATA_LENGTH); // '_' mu als Trenner dienen fr Restart_Round_(xxseconds)
      
  /* Spielbeginn oder Restart */
  if (   (strcmp(Data,"Game_Commencing")== 0)
      || (strcmp(WorldAction_1,"Restart") == 0)) {
		
		/* Rundenzhler */
		if (bRoundCounter) { 
		  iRound = 0;
		  sTerrScore = "0";
		  sCtScore = "0";
		}
	
	}

  /* Rundenstart */
  if (strcmp(Data,"Round_Start") == 0) {
    
    /* Rundenzhler */
    if (bRoundCounter) { 
      iRound += 1;
      snprintf(Text, MAX_TEXT_LENGTH, "*** Runde: %i ***^n*** Rundenstand: T ( %s ) - CT ( %s ) ***^n*** Das Team mit einem Rundenstand von %i gewinnt! ***",iRound,sTerrScore,sCtScore,getvar("mp_winlimit"));
      centersay(Text, ANZEIGE_DAUER, 10, 255, 255);
		}

    /* LastScout */
    if (bLastScout_Informiert || bLastScout_Informiert_T || bLastScout_Informiert_CT) {
      bLastScout_Informiert = false;
      bLastScout_Informiert_T = false;
      bLastScout_Informiert_CT = false;
    }
    
    /* Initialisierung der FragAnzahl fr killstreak */
    for(iUserIndex = 1; iUserIndex <= ANZAHLPLAYER; iUserIndex++) {
		  KillCount[iUserIndex] = 0;
	  }
	  
	  /* Initialisierung des Ranking fr bestplayer */
	  for(iUserIndex = 1; iUserIndex <= ANZAHLPLAYER; iUserIndex++) {
	    Ranking[iUserIndex] = 0;
	  }
  }
  return PLUGIN_HANDLED;
}

/* Diese Funktion wird durch das LOGD-Commando "65" Team Score Report
 * aufgerufen.
 * Paramter Format: teamString score numPlayers
 * Examples: TERRORIST 9 7 = terrorists won with a score of 9 and 7 people on the team
 * Nutzung:
 * -> Wegschreiben der gespielten Karte fr die Funktion
 *    >> lade_neuen_mapcycle()
 */
public logd_teamscore(HLCommand,HLData,HLUserName,UserIndex) {

  new Command[MAX_COMMAND_LENGTH];
  new Data[MAX_DATA_LENGTH];
  new UserName[MAX_NAME_LENGTH];
  new Text[MAX_TEXT_LENGTH];
  new Team[MAX_DATA_LENGTH];
  new TeamScore[MAX_DATA_LENGTH];
  new TeamAnzahl[MAX_DATA_LENGTH];
  new GespielteMapGesichert;
  new iUserIndex;

  /* Auslesen des LOGD-Commandos */
  convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // logd_teamscore
  convert_string(HLData,Data,MAX_DATA_LENGTH); // teamString score numPlayers
  convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins

  /* Zuweisen der Parameter auf die jeweiligen Variablen */
  strsplit(Data," ",Team,MAX_DATA_LENGTH,TeamScore,MAX_DATA_LENGTH,TeamAnzahl,MAX_DATA_LENGTH);

  /* Initialisierung der FragAnzahl fr killstreak */
  for(iUserIndex = 1; iUserIndex <= ANZAHLPLAYER; iUserIndex++) {
	  KillCount[iUserIndex] = 0;
	}
  
  /* Initialisierung der FragAnzahl fr headshot */
  for(iUserIndex = 1; iUserIndex <= ANZAHLPLAYER; iUserIndex++) {
	  HeadCount[iUserIndex] = 0;
	}
	
	/* Initialisierung der FragAnzahl fr bestplayer */
	for(iUserIndex = 1; iUserIndex <= ANZAHLPLAYER; iUserIndex++) {
	  FragCount[iUserIndex] = 0;
	}

  /* Team-Prfung CT */
  if (strcmp(Team,"CT") == 0) {
    /* Wegschreiben der gespielten Karte
     * Damit diese Aktion nur einmal ausgefhrt wird, hngt sie an der
     * Teamprfung CT */
    GespielteMapGesichert = GespielteMapSichern();
    if (GespielteMapGesichert == JA) {
      snprintf(Text,MAX_TEXT_LENGTH,"GespielteMap >> Aktuell gespielte Map wurde gespeichert!");
      selfmessage(Text);
    }
    /* Der Wechsel war nicht erfolgreich */
    else {
      snprintf(Text,MAX_TEXT_LENGTH,"GespielteMap >> Aktuell gespielte Map wurde nicht gespeichert! -> s. Logfile");
      selfmessage(Text);
    }
  }
  return PLUGIN_HANDLED;
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------

/* Wegschreiben der gespielten Karte
 */
GespielteMapSichern() {

  new bReadLine = true;
  new iReadLine = 1;
  new iWriteLine = 1;
  new bWriteLine = true;
  new sGespielteMap[MAX_TEXT_LENGTH];
  new sAktuelleMap[MAX_TEXT_LENGTH];
  new Text[MAX_TEXT_LENGTH];
  new Ergebnis = NEIN;

  /* Prfung, ob die bentigte Datei vorhanden ist und gelesen
   * bzw. beschrieben werden darf */
  if (fileexists(MAPS_GESPIELT) > 0) {
    /* Ermittlung der aktuellen Karte */
    if (currentmap(sAktuelleMap,MAX_TEXT_LENGTH)) {
      /* Erstes Lesen */
      bReadLine = readfile(MAPS_GESPIELT,sGespielteMap,iReadLine,MAX_TEXT_LENGTH);
      /* Erste Zeile schon belegt
       * Ermittlung der nchsten freien Zeile */
      while (bReadLine) {
        ++iReadLine;
        bReadLine = readfile(MAPS_GESPIELT,sGespielteMap,iReadLine,MAX_TEXT_LENGTH);
      }
      if (getvar("file_access_read") == 1) {
        /* Schreiben der aktuell gespielten Map in die freie Zeile */
        iWriteLine = iReadLine;
        bWriteLine = writefile(MAPS_GESPIELT,sAktuelleMap,iWriteLine);
        /* Schreiben war erfolgreich */
        if (bWriteLine) {
          Ergebnis = JA;
        }
        else {
          snprintf(Text,MAX_TEXT_LENGTH,"GespielteMap >> Die aktuell gespielte Map %s wurde nicht in %s geschrieben.",sAktuelleMap,MAPS_GESPIELT);
          log(Text);
          /* Schreibberechtigung ist vorhanden */
          if (getvar("file_access_write") == 1) {
            snprintf(Text,MAX_TEXT_LENGTH,"GespielteMap >> In der Datei %s wurde die Schreibberechtigung vergeben.",SERVERFILE);
            log(Text);
          }
          /* Schreibberechtigung ist nicht vorhanden */
          else {
            snprintf(Text,MAX_TEXT_LENGTH,"GespielteMap >> In der Datei %s wurde keine Schreibberechtigung vergeben.",SERVERFILE);
            log(Text);
          }
        }
      }
      else {
        snprintf(Text,MAX_TEXT_LENGTH,"GespielteMap >> Die Datei %s konnte nicht gelesen werden.",MAPS_GESPIELT);
        log(Text);
        snprintf(Text,MAX_TEXT_LENGTH,"GespielteMap >> In der Datei %s wurde keine Leseberechtigung vergeben.",SERVERFILE);
        log(Text);
      }
    }
    else {
      snprintf(Text,MAX_TEXT_LENGTH,"GespielteMap >> Die aktuelle Map konnte nicht ermittelt werden.");
      log(Text);
    }
  }
  else {
    snprintf(Text,MAX_TEXT_LENGTH,"GespielteMap >> Die Datei %s ist nicht vorhanden.",MAPS_GESPIELT);
    log(Text);
  }
  return(Ergebnis);
}

/* Durchfhrung des Mapcyclewechsels
 */
lade_neuen_mapcycle(NewMapCycleFile[] = "") {

  new bReadLine = true;
  new bReadLine_2 = true;
  new bReadLine_3 = true;
  new bResetFile = true;
  new bWriteLine = true;
  new bMapWrite = true;
  new bFehler = false;
  new bGespielteMapsSchreiben = false;
  new bAlleMapsGeschrieben = false;
  new sResultLine[MAX_TEXT_LENGTH];
  new sMapCycleFile[MAX_NAME_LENGTH];
  new sMap[MAX_TEXT_LENGTH];
  new sMapGespielt[MAX_TEXT_LENGTH];
  new sMapGeschrieben[MAX_TEXT_LENGTH];
  new iReadLine = 1;
  new iReadLine_2 = 1;
  new iReadLine_3 = 1;
  new iWriteLine = 1;
  new Ergebnis = NEIN;
  new Text[MAX_TEXT_LENGTH];

  /* Ermittlung der aktuellen Mapcycle-Quelle */
  bReadLine = readfile(MAPCYCLE_SOURCE,sMapCycleFile,iReadLine,MAX_TEXT_LENGTH);
  /* Name der Mapcycle-Quelle wurde nicht ausgelesen
   * oder der Name wurde ausgelesen, aber die Datei existiert nicht
   * oder der Name entspricht dem Original-Mapcycle */
  if (   (!bReadLine)
      || (bReadLine && fileexists(sMapCycleFile) == 0)
      || (strcmp(sMapCycleFile,MAPCYCLEFILE) == 0)) {
    /* Initialisierung mit dem Init-Mapcyclefile */
    sMapCycleFile = MAPCYCLE_INIT;
  }
  /* Prfung, ob die bentigten Dateien vorhanden sind und gelesen
   * bzw. beschrieben werden drfen */
  if (   fileexists(NewMapCycleFile) > 0 && fileexists(MAPCYCLEFILE) > 0
      && fileexists(MAPCYCLE_SOURCE) > 0 && fileexists(MAPS_GESPIELT) > 0
      && fileexists(MAPCYCLE_TEMP) > 0 && fileexists(sMapCycleFile) > 0) {
    /* Zurckschreiben des alten Mapcycle unter Bercksichtigung der
     * schon gespielten Maps */
    bReadLine = readfile(sMapCycleFile,sMap,iReadLine,MAX_TEXT_LENGTH);
    bReadLine_2 = readfile(MAPS_GESPIELT,sMapGespielt,iReadLine_2,MAX_TEXT_LENGTH);
    bResetFile = resetfile(MAPCYCLE_TEMP);
    /* Mapcyclefiles existieren, erste Map im Mapcycle ausgelesen
     * und temporre Mapcycle-Datei gelscht
     * Das Lesen der schon gespielten Maps kann ungltig sein! */
    if (bReadLine && bResetFile) {
      /* Es werden alle Maps aus der Mapcycle-Quelle ausgelesen und
       * und in die Mapcycle-Quelle wieder zurckgeschrieben
       * (exkl. Rckrundenmaps).
       * Hierbei wird die Reihenfolge des zurckgeschriebenen Mapcycles
       * dahingehend verndert, da zuerst die nichtgespielten und
       * danach erst die gespielten Maps aufgefhrt werden. */
      while (!bAlleMapsGeschrieben && !bFehler) {
      //  log("1. Schleife - Begin");
        /* Auslesen des alten Mapcycle */
        while (bReadLine && !bFehler) {
      //    log("2. Schleife - Begin");
          /* Eine Map wird nur dann in den Mapcycle aufgenommen, wenn sie
           * 1. im MAPS.INI und
           * 2. im Map-Ordner
           * vorhanden ist */
          if (valid_map(sMap) == 1) {
            /* Prfung, ob die Map gespielt wurde */
            while (strcmp(sMap,sMapGespielt) != 0 && bReadLine_2 && !bFehler) {
      //        log("3. Schleife - Begin");
              ++iReadLine_2;
              bReadLine_2 = readfile(MAPS_GESPIELT,sMapGespielt,iReadLine_2,MAX_TEXT_LENGTH);
            }
      //      log("3. Schleife - END");
            /* Die Map wurde gespielt */
            if (strcmp(sMap,sMapGespielt) == 0 && bGespielteMapsSchreiben) {
              /* berprfen, ob die Map schon einmal weggeschrieben
               * wurde */
              bReadLine_3 = true;
              iReadLine_3 = 1;
              while (strcmp(sMap,sMapGeschrieben) != 0 && bReadLine_3) {
      //          log("4. Schleife - Begin");
                bReadLine_3 = readfile(MAPCYCLE_TEMP,sMapGeschrieben,iReadLine_3,MAX_TEXT_LENGTH);
                ++iReadLine_3;
              }
      //        log("4. Schleife - END");
              /* Map wurde noch nicht weggeschrieben */
              if (strcmp(sMap,sMapGeschrieben) != 0) {
                bWriteLine = writefile(MAPCYCLE_TEMP,sMap,iWriteLine);
                /* Map konnte nicht geschrieben werden */
                if (!bWriteLine) {
                  bFehler = true;
                }
                ++iWriteLine;
              }
            }
            /* Die Map wurde nicht gespielt */
            if (strcmp(sMap,sMapGespielt) != 0 && !bGespielteMapsSchreiben) {
              /* berprfen, ob die Map schon einmal weggeschrieben
               * wurde */
              bReadLine_3 = true;
              iReadLine_3 = 1;
              while (strcmp(sMap,sMapGeschrieben) != 0 && bReadLine_3) {
      //          log("5. Schleife - Begin");
                bReadLine_3 = readfile(MAPCYCLE_TEMP,sMapGeschrieben,iReadLine_3,MAX_TEXT_LENGTH);
                ++iReadLine_3;
              }
      //        log("5. Schleife - END");
              /* Map wurde noch nicht weggeschrieben */
              if (strcmp(sMap,sMapGeschrieben) != 0) {
                bWriteLine = writefile(MAPCYCLE_TEMP,sMap,iWriteLine);
                /* Map konnte nicht geschrieben werden */
                if (!bWriteLine) {
                  bFehler = true;
                }
                ++iWriteLine;
              }
            }
            ++iReadLine;
            bReadLine = readfile(sMapCycleFile,sMap,iReadLine,MAX_TEXT_LENGTH);
            bReadLine_2 = true;
            iReadLine_2 = 1;
          }
          /* Der Mapname wird nicht anerkannt */
          else {
            bMapWrite = false;
            snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Map %s steht nicht in %s -> wird daher nicht uebernommen.",sMap,MAPSINI);
            log(Text);
            /* Lesen der nchsten Karte fr die Weiterverarbeitung */
            ++iReadLine;
            bReadLine = readfile(sMapCycleFile,sMap,iReadLine,MAX_TEXT_LENGTH);
          }
        }
      //  log("2. Schleife - END");
        /* Nicht gespielte Maps wurden gesichert */
        if (!bGespielteMapsSchreiben) {
          bGespielteMapsSchreiben = true;
          bReadLine = true;
          iReadLine = 1;
          bReadLine = readfile(sMapCycleFile,sMap,iReadLine,MAX_TEXT_LENGTH);
          iReadLine_2 = 1;
          bReadLine_2 = readfile(MAPS_GESPIELT,sMapGespielt,iReadLine_2,MAX_TEXT_LENGTH);
        }
        /* Gespielte Maps wurden gesichert */
        /* => Alle Maps gesichert */
        else {
          bAlleMapsGeschrieben = true;
        }
      }
      // log("1. Schleife - END");
      /* Alle Maps wurden erfolgreich gesichert */
      /* Kopieren der temporren Datei in die Mapcycle-Quelle */
      if (!bFehler) {
        iReadLine = 1;
        iWriteLine = iReadLine;
        bReadLine = readfile(MAPCYCLE_TEMP,sMap,iReadLine,MAX_TEXT_LENGTH);
        /* Lesen war erfolgreich */
        if (bReadLine) {
          /* Lschung der Mapcycle-Quelle */
          bResetFile = resetfile(sMapCycleFile);
          /* Lschung der alten Daten durchgefhrt */
          if (bResetFile) {
            /* Kopieren der Maps in die Mapcycle-Quelle*/
            while (bReadLine) {
              bWriteLine = writefile(sMapCycleFile,sMap,iWriteLine);
              ++iReadLine;
              iWriteLine = iReadLine;
              bReadLine = readfile(MAPCYCLE_TEMP,sMap,iReadLine,MAX_TEXT_LENGTH);
            }
            /* Lschung der zum alten Mapcycle gehrenden gespielten
             * Maps */
            bResetFile = resetfile(MAPS_GESPIELT);
            /* Lschung der temporren Datei */
            bResetFile = resetfile(MAPCYCLE_TEMP);
          }
        }
      }
    }
    /* Laden des neuen Mapcycle */
    /* Erster Leseversuch */
    iReadLine = 1;
    iWriteLine = 1;
    bReadLine = readfile(NewMapCycleFile,sResultLine,iReadLine,MAX_TEXT_LENGTH);
    if (bReadLine) {
      /* alte Mapcycle lschen */
      bResetFile = resetfile(MAPCYCLEFILE);
      /* Lschung hat nicht geklappt */
      if (!bResetFile) {
        snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Die Datei %s konnte nicht geloescht werden.",MAPCYCLEFILE);
        log(Text);
        /* Schreibberechtigung ist vorhanden */
        if (getvar("file_access_write") == 1) {
          snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> In der Datei %s wurde die Schreibberechtigung vergeben.",SERVERFILE);
          log(Text);
        }
        /* Schreibberechtigung ist nicht vorhanden */
        else {
          snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> In der Datei %s wurde keine Schreibberechtigung vergeben.",SERVERFILE);
          log(Text);
        }
      }
    }
    /* Erster Leseversuch ist fehlgeschlagen */
    else {
      snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Die Datei %s konnte nicht gelesen werden.",NewMapCycleFile);
      log(Text);
      /* Prfung, ob die Leseberechtigung vorhanden ist */
      if (getvar("file_access_read") == 1) {
        snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> In der Datei %s wurde die Leseberechtigung vergeben.",SERVERFILE);
        log(Text);
      }
      /* Leseberechtigung ist nicht vorhanden */
      else {
        snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> In der Datei %s wurde keine Leseberechtigung vergeben.",SERVERFILE);
        log(Text);
      }
    }
    /* Auslesen und schreiben der Zeilen
     * sofern alle Lese- und Schreibrechte und die Daten vorhanden sind */
    while (bReadLine && bResetFile && bWriteLine) {
      /* Eine Map wird nur dann in den Mapcycle aufgenommen, wenn sie
       * 1. im MAPSINI und
       * 2. im Map-Ordner
       * vorhanden ist */
      if (valid_map(sResultLine) == 1) {
        bWriteLine = writefile(MAPCYCLEFILE,sResultLine,iWriteLine);
        /* Prfung, ob das Schreiben inkl. der Schreibberechtigung
         * erfolgreich war */
        if (bWriteLine) {
          /* Mit Rckrunde */
          if (bRueckrunde) {
            ++iWriteLine;
            bWriteLine = writefile(MAPCYCLEFILE,sResultLine,iWriteLine);
          }
          snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Die Map %s wurde uebernommen.",sResultLine);
          log(Text);
          ++iWriteLine;
          Ergebnis = JA;
        }
        /* Trotz der Schreibberechtigung konnte die Datei nicht
         * beschrieben werden */
        else {
          bMapWrite = false;
          snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Die Map %s konnte nicht geschrieben werden.",sResultLine);
          log(Text);
        }
      }
      /* Der Mapname wird nicht anerkannt */
      else {
        bMapWrite = false;
        snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Map %s steht nicht in %s -> wird daher nicht uebernommen.",sResultLine,MAPSINI);
        log(Text);
      }
      /* Auslesen */
      ++iReadLine;
      bReadLine = readfile(NewMapCycleFile,sResultLine,iReadLine,MAX_TEXT_LENGTH);
    }
    /* Sicherung des benutzten Mapcycles in die Datei MAPCYCLE_SOURCE */
    /* MAPCYCLE_SOURCE existiert */
    bResetFile = resetfile(MAPCYCLE_SOURCE);
    /* Lschung der alten Daten durchgefhrt */
    if (bResetFile) {
      iWriteLine = 1;
      bWriteLine = writefile(MAPCYCLE_SOURCE,NewMapCycleFile,iWriteLine);
      /* Prfung, ob das Schreiben erfolgreich war */
      if (bWriteLine) {
        snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Der Mapcycle %s wurde in %s gesichert.",NewMapCycleFile,MAPCYCLE_SOURCE);
        log(Text);
      }
    }
    if (!bResetFile || !bWriteLine) {
      snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Der Mapcycle %s wurde nicht %s gesichert.",NewMapCycleFile,MAPCYCLE_SOURCE);
      log(Text);
      /* Schreibberechtigung ist vorhanden */
      if (getvar("file_access_write") == 1) {
        snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> In der Datei %s wurde die Schreibberechtigung vergeben.",SERVERFILE);
        log(Text);
      }
      /* Schreibberechtigung ist nicht vorhanden */
      else {
        snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> In der Datei %s wurde keine Schreibberechtigung vergeben.",SERVERFILE);
        log(Text);
      }
    }
  }
  /* Datei(en) ist(sind) nicht vorhanden */
  else {
    if (fileexists(NewMapCycleFile) == 0) {
      snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Die Datei %s ist nicht vorhanden.",NewMapCycleFile);
      log(Text);
    }
    if (fileexists(MAPCYCLEFILE) == 0) {
      snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Die Datei %s ist nicht vorhanden.",MAPCYCLEFILE);
      log(Text);
    }
    if (fileexists(MAPCYCLE_SOURCE) == 0) {
      snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Die Datei %s ist nicht vorhanden.",MAPCYCLE_SOURCE);
      log(Text);
    }
    if (fileexists(MAPS_GESPIELT) == 0) {
      snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Die Datei %s ist nicht vorhanden.",MAPS_GESPIELT);
      log(Text);
    }
    if (fileexists(MAPCYCLE_TEMP) == 0) {
      snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Die Datei %s ist nicht vorhanden.",MAPCYCLE_TEMP);
      log(Text);
    }
    if (fileexists(sMapCycleFile) == 0) {
      snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Die Datei %s ist nicht vorhanden.",sMapCycleFile);
      log(Text);
    }
  }
  /* Meldung, wenn nicht alle Maps aus dem neuen Mapcycle bernommen
   * worden sind */
  if (!bMapWrite) {
    snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Es wurden nicht alle Maps geschrieben -> s. Logfile.");
    selfmessage(Text);
  }
  return(Ergebnis);
}

/* Diese Funktion wird nach Eingabe des Befehls "admin_mapcycle <n> in
 * der Console aufgerufen.
 * Hier wird der Wechsel des Mapcycles initiert.
 * Die mglichen Mapcycles stehen in der Datei MAPCYCLE_AUSWAHL:
 * <Nummer><Blank><Dateiname.txt>
 */
public admin_mapcycle(HLCommand,HLData,HLUserName,UserIndex) {
  
  new Command[MAX_COMMAND_LENGTH];
  new Data[MAX_DATA_LENGTH];
  new UserName[MAX_NAME_LENGTH];
  new Text[MAX_TEXT_LENGTH];
  new sMapCycleFile[MAX_NAME_LENGTH];
  new MapCycleGeladen;
  new bReadLine = true;
  new bGefunden = false;
  new sResultLine[MAX_TEXT_LENGTH];
  new iReadLine = 1;
  new sNumber[MAX_DATA_LENGTH];
 
  /* Auslesen des Consolen-Commandos */
  convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // admin_mapcycle
  convert_string(HLData,Data,MAX_DATA_LENGTH); // Nummer der ausgewhlten Mapcycle
  convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins

  /* Prfung, ob die bentigten Datei vorhanden ist und gelesen
   * werden kann */
  if (fileexists(MAPCYCLE_AUSWAHL) > 0) {
    /* Prfung der Leseberechtigung durch Auslesen der ersten Zeile */
    bReadLine = readfile(MAPCYCLE_AUSWAHL,sResultLine,iReadLine,MAX_TEXT_LENGTH);
    if (bReadLine) {
      /* Lesen der Zeilen bis die entsprechende FileNumber gefunden wurde */
      while (bReadLine && !bGefunden) {
        /* Zuweisen der Parameter auf die jeweiligen Variablen
         * Die Datei hat den folgenden Aufbau: <Number><Blank><FileName> */
        strsplit(sResultLine," ",sNumber,MAX_DATA_LENGTH,sMapCycleFile,MAX_NAME_LENGTH);
        log(sNumber);
        log(sMapCycleFile);
        /* Nummer wurde in der Datei gefunden */
        if (strcmp(Data,sNumber) == 0)
        {
          bGefunden = true;  
        }
        /* Nchste Zeile lesen */
        else {
          ++iReadLine;
          bReadLine = readfile(MAPCYCLE_AUSWAHL,sResultLine,iReadLine,MAX_TEXT_LENGTH);
        }
      }
      /* Nummer ist in der Datei vorhanden */
      if (bGefunden) {
        MapCycleGeladen = lade_neuen_mapcycle(sMapCycleFile);
        /* Der Wechsel war erfolgreich */
        if (MapCycleGeladen == JA) {
          snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Mapcycle %s wurde geladen!",sMapCycleFile);
          selfmessage(Text);
        }
        /* Der Wechsel war nicht erfolgreich */
        else {
          snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Mapcycle %s wurde nicht geladen!",sMapCycleFile);
          selfmessage(Text);
        }
      }    
      else {
        snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Mapcycle_Nummer %s ist unbekannt!",Data);
        selfmessage(Text);
      }
    }
    /* Erster Leseversuch ist fehlgeschlagen */
    else {
      snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Die Datei %s konnte nicht gelesen werden.",MAPCYCLE_AUSWAHL);
      log(Text);
      /* Prfung, ob die Leseberechtigung vorhanden ist */
      if (getvar("file_access_read") == 1) {
        snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> In der Datei %s wurde die Leseberechtigung vergeben.",MAPCYCLE_AUSWAHL);
        log(Text);
      }
      /* Leseberechtigung ist nicht vorhanden */
      else {
        snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> In der Datei %s wurde keine Leseberechtigung vergeben.",MAPCYCLE_AUSWAHL);
        log(Text);
      }
    }
  }
  else {
    snprintf(Text,MAX_TEXT_LENGTH,"NewMapCycle >> Die Datei %s ist nicht vorhanden.",MAPCYCLE_AUSWAHL);
    log(Text);
  }
  
  return PLUGIN_HANDLED;
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------

/* Durchfhren der Rckrunde
 */
durchfuehren_Rueckrunde() {

  new sMapCycleFile[MAX_NAME_LENGTH];
  new iReadLine = 1;
  new bReadLine = true;
  new Ergebnis = NEIN;

  /* Ermittlung der aktuellen Mapcycle-Quelle */
  bReadLine = readfile(MAPCYCLE_SOURCE,sMapCycleFile,iReadLine,MAX_TEXT_LENGTH);
  /* Name der Ursprungsdatei wurde nicht ausgelesen
   * oder der Name wurde ausgelesen, aber die Datei existiert nicht
   * oder der Name entspricht dem Original-Mapcycle */
  if (   (!bReadLine)
      || (bReadLine && fileexists(sMapCycleFile) == 0)
      || (strcmp(sMapCycleFile,MAPCYCLEFILE) == 0)) {
    /* Initialisierung mit dem Init-Mapcyclefile */
    sMapCycleFile = MAPCYCLE_INIT;
  }

  Ergebnis = lade_neuen_mapcycle(sMapCycleFile);

  return(Ergebnis);
}

/* Diese Funktion wird nach Eingabe des Befehls "admin_returnmatch <n> in
 * der Console aufgerufen.
 * Hier wird die Rckrunde initiert.
 */
public admin_returnmatch(HLCommand,HLData,HLUserName,UserIndex) {

  new Command[MAX_COMMAND_LENGTH];
  new Data[MAX_DATA_LENGTH];
  new cRueckrundeStatus[MAX_DATA_LENGTH];
  new UserName[MAX_NAME_LENGTH];
  new Text[MAX_TEXT_LENGTH];
  new DurchGefuehrtRueckRunde;

  /* Auslesen des Consolen-Commandos */
  convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // admin_returnmatch
  convert_string(HLData,Data,MAX_DATA_LENGTH); // Status Rckrunde
  convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins

  if (strcmp(Data,"0") == 0)	{
    bRueckrunde = false;
    DurchGefuehrtRueckRunde = durchfuehren_Rueckrunde();
    if (DurchGefuehrtRueckRunde == JA) {
      set_vaultdata("admin_returnmatch",Data);
      snprintf(Text,MAX_TEXT_LENGTH,"Rueckrunde ist ausgeschaltet.");
      selfmessage(Text);
      }
      else {
        bRueckrunde = true;
        cRueckrundeStatus[0] = '1';
        set_vaultdata("admin_returnmatch",cRueckrundeStatus);
        snprintf(Text,MAX_TEXT_LENGTH,"Rueckrunde konnte nicht ausgeschaltet werden -> s. Logfile.");
        selfmessage(Text);
      }

  }
  else {
    if(strcmp(Data,"1") == 0) {
      bRueckrunde = true;
      DurchGefuehrtRueckRunde = durchfuehren_Rueckrunde();
      if (DurchGefuehrtRueckRunde == JA) {
        set_vaultdata("admin_returnmatch",Data);
        snprintf(Text,MAX_TEXT_LENGTH,"Rueckrunde ist eingeschaltet.");
        selfmessage(Text);
      }
      else {
        bRueckrunde = false;
        cRueckrundeStatus[0] = '0';
        set_vaultdata("admin_returnmatch",cRueckrundeStatus);
        snprintf(Text,MAX_TEXT_LENGTH,"Rueckrunde konnte nicht eingeschaltet werden -> s. Logfile.");
        selfmessage(Text);
      }
    }
    else {
      get_vaultdata("admin_returnmatch",Data,MAX_DATA_LENGTH);
      snprintf(Text,MAX_TEXT_LENGTH,"Ungueltiger Wert fuer admin_returnmatch");
      selfmessage(Text);
      snprintf(Text,MAX_TEXT_LENGTH,"0: Rueckrunde Aus, 1: Rueckrunde An.");
      selfmessage(Text);
      snprintf(Text,MAX_TEXT_LENGTH,"Rueckrunden-Status: %s",Data);
      selfmessage(Text);
    }
  }
  return PLUGIN_HANDLED;
}

/* Diese Funktion wird nach Eingabe des Befehls "admin_roundcount <n> in
 * der Console aufgerufen.
 * Hier wird die Anzeige des Rundenstandes initiert.
 */
public admin_roundcount(HLCommand,HLData,HLUserName,UserIndex) {

	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new cRoundCounterStatus[MAX_DATA_LENGTH];
	
	/* Auslesen des Consolen-Commandos */
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // admin_roundcount
	convert_string(HLData,Data,MAX_DATA_LENGTH); // Status Rundenzhler
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins
	
	/* Anzeige des Rundenzhler */
	if (strcmp(Data,"1") == 0) {
	  bRoundCounter = true;
	  cRoundCounterStatus[0] = '1';
	  set_vaultdata("admin_roundcount",cRoundCounterStatus);
	  snprintf(Text,MAX_TEXT_LENGTH,"Rundenzaehler ist eingeschaltet.");
	  selfmessage(Text);
	}
	else {
		if (strcmp(Data,"0") == 0) {
		  bRoundCounter = false;
		  cRoundCounterStatus[0] = '0';
		  set_vaultdata("admin_roundcount",cRoundCounterStatus);
		  snprintf(Text,MAX_TEXT_LENGTH,"Rundenzaehler ist ausgeschaltet.");
		  selfmessage(Text);
		}
		else 
    {
   	  get_vaultdata("admin_roundcount",Data,MAX_DATA_LENGTH);
   	  snprintf(Text,MAX_TEXT_LENGTH,"Rundenzaehler Status: %s",Data);
   	  selfmessage("Ungueltiger Wert fuer admin_roundcount");
   	  selfmessage("0: Rundenzaehler Aus, 1: Rundenzaehler An.");
   	  selfmessage(Text);
    }
  }
	
	return PLUGIN_HANDLED;
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------

/* Diese Funktion wird nach Eingabe des Befehls "admin_lastscout <n> in
 * der Console aufgerufen.
 * Hier wird die Anzeige des LastScout initiert.
 */
public admin_lastscout(HLCommand,HLData,HLUserName,UserIndex) {

	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new cLastScoutStatus[MAX_DATA_LENGTH];
	
	/* Auslesen des Consolen-Commandos */
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // admin_lastscout
	convert_string(HLData,Data,MAX_DATA_LENGTH); // Status LastScout
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins
	
	/* Anzeige des LastScout */
	if (strcmp(Data,"1") == 0) {
	  bLastScout = true;
	  cLastScoutStatus[0] = '1';
	  set_vaultdata("admin_lastscout",cLastScoutStatus);
	  snprintf(Text,MAX_TEXT_LENGTH,"LastScout ist eingeschaltet.");
	  selfmessage(Text);
	}
	else {
		if (strcmp(Data,"0") == 0) {
		  bLastScout = false;
		  cLastScoutStatus[0] = '0';
		  set_vaultdata("admin_lastscout",cLastScoutStatus);
		  snprintf(Text,MAX_TEXT_LENGTH,"LastScout ist ausgeschaltet.");
		  selfmessage(Text);
		}
		else 
    {
   	  get_vaultdata("admin_lastscout",Data,MAX_DATA_LENGTH);
   	  snprintf(Text,MAX_TEXT_LENGTH,"LastScout Status: %s",Data);
   	  selfmessage("Ungueltiger Wert fuer admin_lastscout");
   	  selfmessage("0: LastScout Aus, 1: LastScout An.");
   	  selfmessage(Text);
    }
  }
	
	return PLUGIN_HANDLED;
}

/* Prfen, ob es einen LastScout gibt
 */
pruefe_LastScout() {
  
  new Text[MAX_TEXT_LENGTH];
  new Win_Sound[MAX_TEXT_LENGTH];
  new DefaultWin_Sound[MAX_TEXT_LENGTH]="misc/theone.wav";
  new Herkunft[MAX_TEXT_LENGTH]="LastScout";
  new Ergebnis = NEIN;
  new sPlayerName[MAX_NAME_LENGTH];
  new iPlayerIndex;
  new iUserID;
  new iWONID;
  new iTeam;
  new iDead;
  new LastScout_T[MAX_NAME_LENGTH];
  new LastScout_CT[MAX_NAME_LENGTH];
  new Anzahl_T = 0;
  new Anzahl_CT = 0;	
	
  //log("==================== Last Scout ===================");
  
  /* Initialisierung */
  Anzahl_T = 0;
  Anzahl_CT = 0;	
	strinit(sPlayerName);
	
  /* Ermittle die Anzahl der lebenden Mitglieder der beiden Teams */
  for (iPlayerIndex = 1; iPlayerIndex <= ANZAHLPLAYER; iPlayerIndex++) {
		// Get the sPlayerName, iUserId, iWONID, iTeam and iDead status of the player represented by iPlayerIndex.
		if (playerinfo(iPlayerIndex,sPlayerName,MAX_NAME_LENGTH,iUserID,iWONID,iTeam,iDead)) {
		  /* Terror-Team */
			if ((iDead == NEIN) && (iTeam == TEAM_TERROR)) {
				Anzahl_T++;
				LastScout_T = sPlayerName;
			}
			/* Counter-Team */
			if ((iDead == NEIN) && (iTeam == TEAM_COUNTER)) {
				Anzahl_CT++;
				LastScout_CT = sPlayerName;
			}
    }
	}
	
	// log(LastScout_T);
	// log(LastScout_CT);
	
	/* Prfe, ob es einen LastScout gibt */
  /* im Terror-Team */
  if ((!bLastScout_Informiert_T) && (Anzahl_T == LAST_MAN) && (Anzahl_CT > LAST_MAN)) {
    ausgabe_LastScout_Spruch(TEAM_TERROR, LastScout_T, LastScout_CT);
    bLastScout_Informiert_T = true;
	}
	
	/* im Counter-Team */
  if ((!bLastScout_Informiert_CT) && (Anzahl_CT == LAST_MAN) && (Anzahl_T > LAST_MAN)) {
	  ausgabe_LastScout_Spruch(TEAM_COUNTER, LastScout_T, LastScout_CT);
	  bLastScout_Informiert_CT = true;
	}
	
	/* in beiden Teams */
  if ((Anzahl_CT == LAST_MAN) && (Anzahl_T == LAST_MAN)) {
	  ausgabe_LastScout_Spruch(BEIDE_TEAMS, LastScout_T, LastScout_CT);
	  Ergebnis = JA;
	}
	
	/* Prfe, ob ein LastScout gewonnen hat */
  if (   (Anzahl_T == LAST_MAN) && (Anzahl_CT == 0)
      || (Anzahl_CT == LAST_MAN) && (Anzahl_T == 0)) {
	  /* Ermittlung des Sound-Spruches */ 
    Ergebnis = ermittleZufallsZeile(LASTSCOUT_WIN_SPRUECHE,Herkunft);  
  
    /* Spruch ermittelt */
    if (Ergebnis == JA) {
      Win_Sound = ZUFALLSZEILE;
    }
    else {
      Win_Sound = DefaultWin_Sound;
    }
  }
	
	/* Prfe, ob der LastScout gewonnen hat */
	/* fr das Terror-Team */
  if ((Anzahl_T == LAST_MAN) && (Anzahl_CT == 0)) {
	  playsound(LastScout_T, Win_Sound);
	  playsound(LastScout_CT, "misc/astalavi.wav");	
	}
	/* fr das Counter-Team */
  if ((Anzahl_CT == LAST_MAN) && (Anzahl_T == 0)) {
	  playsound(LastScout_CT, Win_Sound);
    	  playsound(LastScout_T, "misc/astalavi.wav");	
	}
  
  return (Ergebnis);
}

/* Ausgabe eines Bildschirmtextes in Teamfarbe fr den LastScout
 */
ausgabe_LastScout_Spruch(Team, LastScout_T[MAX_NAME_LENGTH], LastScout_CT[MAX_NAME_LENGTH]) {
  
  new Text[MAX_TEXT_LENGTH];
  new Spruch_Text[MAX_TEXT_LENGTH];
  new Spruch_Sound[MAX_TEXT_LENGTH];
  new DefaultSpruch_Text[MAX_TEXT_LENGTH]="It's Show Time";
  new DefaultSpruch_Sound[MAX_TEXT_LENGTH]="misc/force.wav";
  new Herkunft[MAX_TEXT_LENGTH]="LastScout";
  new Ergebnis = NEIN;
  
  /* Ermittlung des Text-Spruches */
  Ergebnis = ermittleZufallsZeile(LASTSCOUT_TEXTE,Herkunft);  
  
  /* Spruch ermittelt */
  if (Ergebnis == JA && strlen(ZUFALLSZEILE) > 0) {
    Spruch_Text = ZUFALLSZEILE;
  }
  else {
    Spruch_Text = DefaultSpruch_Text;
  }
  
  /* Ermittlung des Sound-Spruches */
  Ergebnis = ermittleZufallsZeile(LASTSCOUT_SPRUECHE,Herkunft);  
  
  /* Spruch ermittelt */
  if (Ergebnis == JA && strlen(ZUFALLSZEILE) > 0) {
    Spruch_Sound = ZUFALLSZEILE;
  }
  else {
    Spruch_Sound = DefaultSpruch_Sound;
  }
  
  /* 1 : n */
  if (Team != BEIDE_TEAMS) {
    /* Prfung, ob der Terror benachrichtigt wird */
    if (!bLastScout_Informiert_T && Team == TEAM_TERROR) {
      // log("====== Terror ========");
      /* Ausgabe des Textes nur an den LastScout */
      messageex(LastScout_T,Spruch_Text,4); // Centersay tty
      /* Ausgabe des Spruches nur an den LastScout */
      playsound(LastScout_T, Spruch_Sound);  
    }
    /* Prfung, ob der Counter benachrichtigt wird */
    else if (!bLastScout_Informiert_CT && Team == TEAM_COUNTER) {
      // log("====== Counter ========");
      /* Ausgabe des Textes nur an den LastScout */
      messageex(LastScout_CT,Spruch_Text,4); // Centersay tty
      /* Ausgabe des Spruches nur an den LastScout */
      playsound(LastScout_CT, Spruch_Sound);
    }
  }
  /* 1 : 1 */  
  else {
	  snprintf(Text, MAX_TEXT_LENGTH, "%s vs %s", LastScout_T, LastScout_CT);
	  centersay(Text, ANZEIGE_DAUER, 0, 255, 0);
	  if (!bLastScout_Informiert_T) {
	    /* Ausgabe des Spruches nur an den LastScout */
      playsound(LastScout_T, Spruch_Sound);
    }
    else if (!bLastScout_Informiert_CT) {
      /* Ausgabe des Spruches nur an den LastScout */
      playsound(LastScout_CT, Spruch_Sound);
    }
  }
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------

/* Diese Funktion wird nach Eingabe des Befehls "admin_announce <n> in
 * der Console aufgerufen.
 * Hier wird die Anzeige des Team-Announce initiert.
 */
public admin_announce(HLCommand,HLData,HLUserName,UserIndex) {

	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new cAnnounceStatus[MAX_DATA_LENGTH];
	
	/* Auslesen des Consolen-Commandos */
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // admin_announce
	convert_string(HLData,Data,MAX_DATA_LENGTH); // Status Team-Announce
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins
	
	/* Anzeige des Team-Announce */
	if (strcmp(Data,"1") == 0) {
	  bAnnounce = true;
	  cAnnounceStatus[0] = '1';
	  set_vaultdata("admin_announce",cAnnounceStatus);
	  snprintf(Text,MAX_TEXT_LENGTH,"Team-Announce ist eingeschaltet.");
	  selfmessage(Text);
	}
	else {
		if (strcmp(Data,"0") == 0) {
		  bAnnounce = false;
		  cAnnounceStatus[0] = '0';
		  set_vaultdata("admin_announce",cAnnounceStatus);
		  snprintf(Text,MAX_TEXT_LENGTH,"Team-Announce ist ausgeschaltet.");
		  selfmessage(Text);
		}
		else 
    {
   	  get_vaultdata("admin_announce",Data,MAX_DATA_LENGTH);
   	  snprintf(Text,MAX_TEXT_LENGTH,"Team-Announce Status: %s",Data);
   	  selfmessage("Ungueltiger Wert fuer admin_announce");
   	  selfmessage("0: Team-Announce Aus, 1: Team-Announce An.");
   	  selfmessage(Text);
    }
  }
	
	return PLUGIN_HANDLED;
}

/* Prfung, ob der Kill ein Team-Kill war
 */
pruefe_TeamKill(iKillerUserIndex, iVictimUserIndex) {

  new Ergebnis = NEIN;
  new KillerName[MAX_NAME_LENGTH];
  new iKillerUserID;
  new iKillerWONID;
  new iKillerTeam;
  new iKillerDead;
  new VictimName[MAX_NAME_LENGTH];  
  new iVictimUserID;
  new iVictimWONID;
  new iVictimTeam;
  new iVictimDead;
  
  /* Initialisierung */
  strinit(KillerName); 
  strinit(VictimName);
  
  /* Ermittlung der Spielernamen */
  // Get the sPlayerName, iUserId, iWONID, iTeam and iDead status of the player represented by iPlayerIndex.
  playerinfo(iKillerUserIndex,KillerName,MAX_NAME_LENGTH,iKillerUserID,iKillerWONID,iKillerTeam,iKillerDead);
  playerinfo(iVictimUserIndex,VictimName,MAX_NAME_LENGTH,iVictimUserID,iVictimWONID,iVictimTeam,iVictimDead);

  /* Team-Kill */
  if (iKillerTeam == iVictimTeam) {
    Ergebnis = JA;  
    /* Ermigung der Fraganzahl des Killers */
    FragCount[iKillerUserIndex] -= 1;
  }
  /* Kein Team-Kill */
  else {
    Ergebnis = NEIN;
    /* Erhhung der Fraganzahl des Killers */
    FragCount[iKillerUserIndex] += 1;
  }
  
  return (Ergebnis);
}

/* Teamkill announce ausfhren  
 * - Anzeige eines Textes fr den Killer
 * - Abspielen eines Zufallssounds fr den Killer
 * - Anzeige eines Textes fr das Opfer
 */
ausfuehren_TeamKillAnnounce(iKillerUserIndex,iVictimUserIndex,KillerWeapon[] = "",Ergebnis_Teamkill) {
    
  new DefaultSpruch[MAX_TEXT_LENGTH]="misc/asshole1.wav";
  new Herkunft[MAX_TEXT_LENGTH]="TeamKill";
  new KillerName[MAX_NAME_LENGTH];
  new iKillerUserID;
  new iKillerWONID;
  new iKillerTeam;
  new iKillerDead;
  new VictimName[MAX_NAME_LENGTH];  
  new iVictimUserID;
  new iVictimWONID;
  new iVictimTeam;
  new iVictimDead;
  new Text[MAX_TEXT_LENGTH];
  new Spruch[MAX_TEXT_LENGTH];
  new Ergebnis = NEIN;
  
  /* Ermittlung der Spielernamen */
  // Get the sPlayerName, iUserId, iWONID, iTeam and iDead status of the player represented by iPlayerIndex.
  playerinfo(iKillerUserIndex,KillerName,MAX_NAME_LENGTH,iKillerUserID,iKillerWONID,iKillerTeam,iKillerDead);
  playerinfo(iVictimUserIndex,VictimName,MAX_NAME_LENGTH,iVictimUserID,iVictimWONID,iVictimTeam,iVictimDead);

  
  /* Ermittlung des Sound-Spruches */ 
  Ergebnis = ermittleZufallsZeile(KILL_SPRUECHE,Herkunft);  
  
  /* Spruch ermittelt */
  if (Ergebnis == JA && strlen(ZUFALLSZEILE) > 0) {
    Spruch = ZUFALLSZEILE;
  }
  else {
    Spruch = DefaultSpruch;
  }
  
  /* Team-Kill */
  if(Ergebnis_Teamkill == JA) {
    /* Nachricht an den Teamkiller */
    snprintf(Text, MAX_TEXT_LENGTH, "Du Bloedel hast mit Deiner %s ^n Deinen Team-Kameraden %s umgenietet!  ;-(", KillerWeapon, VictimName);
    messageex(KillerName,Text,4); // Centersay tty
    playsound(KillerName,Spruch);
    
    /* Nachricht an das Opfer */
    snprintf(Text, MAX_TEXT_LENGTH, "Dein blinder Team-Kamerad %s ^n hat Dich mit seiner %s umgenietet!  ;-(", KillerName, KillerWeapon);
    messageex(VictimName,Text,4); // Centersay tty
  }
  
}

/* Prfung, ob der Attack ein Team-Attack war
 */
pruefe_TeamAttack(iAttackerUserIndex, iVictimUserIndex) {

  new AttackerName[MAX_NAME_LENGTH];
  new iAttackerUserID;
  new iAttackerWONID;
  new iAttackerTeam;
  new iAttackerDead;
  new VictimName[MAX_NAME_LENGTH];  
  new iVictimUserID;
  new iVictimWONID;
  new iVictimTeam;
  new iVictimDead;
  new Ergebnis = NEIN;
  
  /* Initialisierung */
  strinit(AttackerName); 
  strinit(VictimName);
  
  /* Ermittlung der Spielernamen */
  // Get the sPlayerName, iUserId, iWONID, iTeam and iDead status of the player represented by iPlayerIndex.
  playerinfo(iAttackerUserIndex,AttackerName,MAX_NAME_LENGTH,iAttackerUserID,iAttackerWONID,iAttackerTeam,iAttackerDead);
  playerinfo(iVictimUserIndex,VictimName,MAX_NAME_LENGTH,iVictimUserID,iVictimWONID,iVictimTeam,iVictimDead);

  /* Team-Attack */
  if (iAttackerTeam == iVictimTeam) {
    Ergebnis = JA;
  }
  else {
    Ergebnis = NEIN;
  }
  
  return (Ergebnis);
}

/* Teamattack announce ausfhren  
 * - Anzeige eines Textes fr den Attacker
 * - Abspielen eines Sounds fr den Attacker
 * - Anzeige eines Textes fr das Opfer
 */
ausfuehren_TeamAttackAnnounce(iAttackerUserIndex,iVictimUserIndex,AttackerWeapon[] = "",Ergebnis_TeamAttack) {
  
  new Text[MAX_TEXT_LENGTH];
  new Spruch[MAX_TEXT_LENGTH];
  new AttackerName[MAX_NAME_LENGTH];
  new iAttackerUserID;
  new iAttackerWONID;
  new iAttackerTeam;
  new iAttackerDead;
  new VictimName[MAX_NAME_LENGTH];  
  new iVictimUserID;
  new iVictimWONID;
  new iVictimTeam;
  new iVictimDead;
  
  /* Ermittlung der Spielernamen */
  // Get the sPlayerName, iUserId, iWONID, iTeam and iDead status of the player represented by iPlayerIndex.
  playerinfo(iAttackerUserIndex,AttackerName,MAX_NAME_LENGTH,iAttackerUserID,iAttackerWONID,iAttackerTeam,iAttackerDead);
  playerinfo(iVictimUserIndex,VictimName,MAX_NAME_LENGTH,iVictimUserID,iVictimWONID,iVictimTeam,iVictimDead);

  /* Team-Attack */
  if (Ergebnis_TeamAttack == JA) {
    /* Nachricht an den TeamAttacker */
    snprintf(Text, MAX_TEXT_LENGTH, "Du Bloedel schiesst mit Deiner %s ^n auf Deinen Team-Kameraden %s !  ;-(", AttackerWeapon, VictimName);
    messageex(AttackerName,Text,4); // Centersay tty
    Spruch = "misc/ow.wav";
    playsound(AttackerName, Spruch);
    
    /* Nachricht an das Opfer */
    snprintf(Text, MAX_TEXT_LENGTH, "Dein blinder Team-Kamerad %s ^n beschiesst Dich mit seiner %s !  ;-(", AttackerName, AttackerWeapon);
    messageex(VictimName,Text,4); // Centersay tty
    Spruch = "misc/ochnoe.wav";
    playsound(VictimName, Spruch);
  }
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------

/* Diese Funktion wird nach Eingabe des Befehls "admin_killstreak <n> in
 * der Console aufgerufen.
 * Hier wird die Anzeige des Team-Announce initiert.
 */
public admin_killstreak(HLCommand,HLData,HLUserName,UserIndex) {

	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new cKillStreakStatus[MAX_DATA_LENGTH];
	
	/* Auslesen des Consolen-Commandos */
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // admin_killstreak
	convert_string(HLData,Data,MAX_DATA_LENGTH); // Status KillStreak
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins
	
	/* Anzeige des KillStreak */
	if (strcmp(Data,"1") == 0) {
	  bKillStreak = true;
	  cKillStreakStatus[0] = '1';
	  set_vaultdata("admin_killstreak",cKillStreakStatus);
	  snprintf(Text,MAX_TEXT_LENGTH,"KillStreak ist eingeschaltet.");
	  selfmessage(Text);
	}
	else {
		if (strcmp(Data,"0") == 0) {
		  bKillStreak = false;
		  cKillStreakStatus[0] = '0';
		  set_vaultdata("admin_killstreak",cKillStreakStatus);
		  snprintf(Text,MAX_TEXT_LENGTH,"KillStreak ist ausgeschaltet.");
		  selfmessage(Text);
		}
		else 
    {
   	  get_vaultdata("admin_killstreak",Data,MAX_DATA_LENGTH);
   	  snprintf(Text,MAX_TEXT_LENGTH,"KillStreak Status: %s",Data);
   	  selfmessage("Ungueltiger Wert fuer admin_killstreak");
   	  selfmessage("0: KillStreak Aus, 1: KillStreak An.");
   	  selfmessage(Text);
    }
  }
	
	return PLUGIN_HANDLED;
}

/* KillStreak ausfhren  
 * - KillCount des Killers erhhen
 * - Killcount des Victims initialisieren
 * bei einem Teamkill
 * - KillCount des Killers abziehen
 */
ausfuehren_killstreak(iKillerUserIndex,iVictimUserIndex,Ergebnis_Teamkill) {
  
  new Herkunft[MAX_TEXT_LENGTH]="KillStreak";
  new KillerName[MAX_NAME_LENGTH];
  new iKillerUserID;
  new iKillerWONID;
  new iKillerTeam;
  new iKillerDead;
  new VictimName[MAX_NAME_LENGTH];  
  new iVictimUserID;
  new iVictimWONID;
  new iVictimTeam;
  new iVictimDead;
  new KillZahl[MAX_DATA_LENGTH];
  new KillStreak_Spruch[MAX_DATA_LENGTH];
  new KillStreak_Text[MAX_DATA_LENGTH];
  new Message[MAX_TEXT_LENGTH] = "%s ";
  new Text[MAX_TEXT_LENGTH];
  new Ergebnis = NEIN;
  
  /* Initialisierung */
  strinit(KillerName); 
  strinit(VictimName);
  
  /* Ermittlung der Spielernamen */
  // Get the sPlayerName, iUserId, iWONID, iTeam and iDead status of the player represented by iPlayerIndex.
  playerinfo(iKillerUserIndex,KillerName,MAX_NAME_LENGTH,iKillerUserID,iKillerWONID,iKillerTeam,iKillerDead);
  playerinfo(iVictimUserIndex,VictimName,MAX_NAME_LENGTH,iVictimUserID,iVictimWONID,iVictimTeam,iVictimDead);
  
  /* Kein Team-Kill */
  if(Ergebnis_Teamkill == NEIN) {
    
    KillCount[iKillerUserIndex] += 1;
    KillCount[iVictimUserIndex] = CLEAN_SLATE;
  
    Ergebnis = ermittleZeile(KILLSTREAK_SPRUECHE,Herkunft,KillCount[iKillerUserIndex]);
    
    /* Zeile mit den AusgabeDaten gefunden */
    if (Ergebnis == JA) {
      /* Zuweisen der Parameter auf die jeweiligen Variablen */
      strsplit(GESUCHTEZEILE,";",KillZahl,MAX_DATA_LENGTH,KillStreak_Spruch,MAX_DATA_LENGTH,KillStreak_Text,MAX_DATA_LENGTH); 
           
      playsound(KillerName,KillStreak_Spruch);
      
      /* Ausgabetext vorhanden */
      if (strlen(KillStreak_Text) > 1) {
        /* Verknpfung der Variablen fr die Anzeige des Spielernamens mit dem Text */
        strcat(Message, KillStreak_Text,MAX_TEXT_LENGTH);
        snprintf(Text, MAX_TEXT_LENGTH, Message, KillerName);
			  typesay(Text, ANZEIGE_DAUER, 255, 15, 15 );
			}
    }
  }
  /* Team-Kill */
  else {
    KillCount[iKillerUserIndex] -=1;
  }
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------

/* Diese Funktion wird nach Eingabe des Befehls "admin_headshot <n> in
 * der Console aufgerufen.
 * Hier wird die Anzeige des Headshot initiert.
 */
public admin_headshot(HLCommand,HLData,HLUserName,UserIndex) {

	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new cHeadShotStatus[MAX_DATA_LENGTH];
	
	/* Auslesen des Consolen-Commandos */
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // admin_headshot
	convert_string(HLData,Data,MAX_DATA_LENGTH); // Status Headshot
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins
	
	/* Anzeige des Headshot */
	if (strcmp(Data,"1") == 0) {
	  bHeadShot = true;
	  cHeadShotStatus[0] = '1';
	  set_vaultdata("admin_headshot",cHeadShotStatus);
	  snprintf(Text,MAX_TEXT_LENGTH,"HeadShot ist eingeschaltet.");
	  selfmessage(Text);
	}
	else {
		if (strcmp(Data,"0") == 0) {
		  bHeadShot = false;
		  cHeadShotStatus[0] = '0';
		  set_vaultdata("admin_headshot",cHeadShotStatus);
		  snprintf(Text,MAX_TEXT_LENGTH,"HeadShot ist ausgeschaltet.");
		  selfmessage(Text);
		}
		else 
    {
   	  get_vaultdata("admin_headshot",Data,MAX_DATA_LENGTH);
   	  snprintf(Text,MAX_TEXT_LENGTH,"HeadShot Status: %s",Data);
   	  selfmessage("Ungueltiger Wert fuer admin_headshot");
   	  selfmessage("0: HeadShot Aus, 1: HeadShot An.");
   	  selfmessage(Text);
    }
  }
	
	return PLUGIN_HANDLED;
}

/* Prfung, ob der Attack ein Headshot war
 */
pruefe_HeadShot(iVictimDamage,iVictimRest_Health,AttackerWeapon[] = "",Ergebnis_Teamkill) {

  new Ergebnis = NEIN;

  /* Victim ist gestorben */
  if (   (iVictimRest_Health < LEBEND)
      /* und kein TeamKill */
      && (Ergebnis_Teamkill == NEIN)
      /* durch Headshot */
	           /* Pistols */
	    && (   (strcmp(AttackerWeapon,"deagle")    == 0 && iVictimDamage >= DAMAGE80)
		      || (strcmp(AttackerWeapon,"elite")     == 0 && iVictimDamage >= DAMAGE40)
		      || (strcmp(AttackerWeapon,"glock18")   == 0 && iVictimDamage >= DAMAGE40)
		      || (strcmp(AttackerWeapon,"p228")      == 0 && iVictimDamage >= DAMAGE40)
		      || (strcmp(AttackerWeapon,"fiveseven") == 0 && iVictimDamage >= DAMAGE40)
		      || (strcmp(AttackerWeapon,"usp")       == 0 && iVictimDamage >= DAMAGE40)
		         /* Shotguns */
		      || (strcmp(AttackerWeapon,"m3")        == 0 && iVictimDamage >= DAMAGE200)
		      || (strcmp(AttackerWeapon,"xm1014")    == 0 && iVictimDamage >= DAMAGE200)
		         /* SMG's */
		      || (strcmp(AttackerWeapon,"ump40")     == 0 && iVictimDamage >= DAMAGE45)
		      || (strcmp(AttackerWeapon,"mac10")     == 0 && iVictimDamage >= DAMAGE40)
	        || (strcmp(AttackerWeapon,"p90")       == 0 && iVictimDamage >= DAMAGE40)
		      || (strcmp(AttackerWeapon,"mp5navy")   == 0 && iVictimDamage >= DAMAGE36)
		      || (strcmp(AttackerWeapon,"tmp")       == 0 && iVictimDamage >= DAMAGE36)
		         /* Rifles */
		      || (strcmp(AttackerWeapon,"awp")       == 0 && iVictimDamage >= DAMAGE155)
		      || (strcmp(AttackerWeapon,"scout")     == 0 && iVictimDamage >= DAMAGE95)
		      || (strcmp(AttackerWeapon,"sg550")     == 0 && iVictimDamage >= DAMAGE70)
		      || (strcmp(AttackerWeapon,"g3sg1")     == 0 && iVictimDamage >= DAMAGE70)
		      || (strcmp(AttackerWeapon,"aug")       == 0 && iVictimDamage >= DAMAGE50)
		      || (strcmp(AttackerWeapon,"sg552")     == 0 && iVictimDamage >= DAMAGE50)
		      || (strcmp(AttackerWeapon,"m4a1")      == 0 && iVictimDamage >= DAMAGE50)
		      || (strcmp(AttackerWeapon,"ak47")      == 0 && iVictimDamage >= DAMAGE50)
		         /* Maschine Gun */
		      || (strcmp(AttackerWeapon,"m249")      == 0 && iVictimDamage >= DAMAGE50) ) ) {
	  
	  Ergebnis = JA;
	}
	else {
	  Ergebnis = NEIN;
	}
	
  return (Ergebnis);
}

/* Headshot ausfhren  
 * - HeadCount des Killers erhhen
 * - Abspielen eines Zufallssounds fr den Killer
 * - Anzeige eines Textes fr alle
 */
ausfuehren_HeadShot(iKillerUserIndex,KillerWeapon[] = "") {
  
  new DefaultSpruch[MAX_TEXT_LENGTH]="misc/perfect.wav";
  new Herkunft[MAX_TEXT_LENGTH]="HeadShot";
  new KillerName[MAX_NAME_LENGTH];
  new iKillerUserID;
  new iKillerWONID;
  new iKillerTeam;
  new iKillerDead;
  new Text[MAX_TEXT_LENGTH];
  new Spruch[MAX_TEXT_LENGTH];
  new Ergebnis = NEIN;
  
  /* Ermittlung der Spielernamen */
  // Get the sPlayerName, iUserId, iWONID, iTeam and iDead status of the player represented by iPlayerIndex.
  playerinfo(iKillerUserIndex,KillerName,MAX_NAME_LENGTH,iKillerUserID,iKillerWONID,iKillerTeam,iKillerDead);
    
  /* Ermittlung des Sound-Spruches */ 
  Ergebnis = ermittleZufallsZeile(HEADSHOT_SPRUECHE,Herkunft);  
  
  /* Spruch ermittelt */
  if (Ergebnis == JA) {
    Spruch = ZUFALLSZEILE;
  }
  else {
    Spruch = DefaultSpruch;
  }
  
  /* Nachricht an den Killer */
  playsound(KillerName,Spruch);
  
  /* Erhhung der Headshotanzahl des Killers */
  HeadCount[iKillerUserIndex] += 1;
  
  /* Nachricht an alle */
  snprintf(Text, MAX_TEXT_LENGTH, "^n %s made a headshot with the %s",KillerName,KillerWeapon);
	typesay(Text, ANZEIGE_DAUER, 255, 255, 255 );
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------

/* Diese Funktion wird nach Eingabe des Befehls "admin_bestplayer <n> in
 * der Console aufgerufen.
 * Hier wird die Anzeige des Headshot initiert.
 */
public admin_bestplayer(HLCommand,HLData,HLUserName,UserIndex) {

	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new cBestPlayerStatus[MAX_DATA_LENGTH];
	
	/* Auslesen des Consolen-Commandos */
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH); // admin_bestplayer
	convert_string(HLData,Data,MAX_DATA_LENGTH); // Status bestplayer
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username des Admins
	
	/* Anzeige des Bestplayer */
	if (strcmp(Data,"1") == 0) {
	  bBestPlayer = true;
	  cBestPlayerStatus[0] = '1';
	  set_vaultdata("admin_bestplayer",cBestPlayerStatus);
	  snprintf(Text,MAX_TEXT_LENGTH,"BestPlayer ist eingeschaltet.");
	  selfmessage(Text);
	}
	else {
		if (strcmp(Data,"0") == 0) {
		  bBestPlayer = false;
		  cBestPlayerStatus[0] = '0';
		  set_vaultdata("admin_bestplayer",cBestPlayerStatus);
		  snprintf(Text,MAX_TEXT_LENGTH,"BestPlayer ist ausgeschaltet.");
		  selfmessage(Text);
		}
		else 
    {
   	  get_vaultdata("admin_bestplayer",Data,MAX_DATA_LENGTH);
   	  snprintf(Text,MAX_TEXT_LENGTH,"BestPlayer Status: %s",Data);
   	  selfmessage("Ungueltiger Wert fuer admin_bestplayer");
   	  selfmessage("0: BestPlayer Aus, 1: BestPlayer An.");
   	  selfmessage(Text);
    }
  }
	
	return PLUGIN_HANDLED;
}

/* Anzeige Bestplayer ausfhren
 * - Absteigende Sortierung nach Frags und Headshots
 */
ausfuehren_Anzeige_BestPlayer() {
  
  new bAlleSpielerGesetzt = false;
  new bSpielerGerankt = false;
  new iBestPlayerID = 1;
  new BestPlayerName[MAX_NAME_LENGTH];
  new iBestPlayerUserID;
  new iBestPlayerWONID;
  new iBestPlayerTeam;
  new iBestPlayerDead;
  new iPlayerID;
  new iPlayerRankingID;
  new Text[MAX_TEXT_LENGTH];
  new Message[MAX_TEXT_LENGTH] = "";
  new iMaxAnzeige = 5;
  new iAnzeigeZaehler = 1;
  
  /* Ranking nur bei mehr als einem anwesenden Spieler */
  if (ANZAHLPLAYER > 1) {
    
    /* Initialisierung */
    bAlleSpielerGesetzt = false;
        
    /* Bearbeitung bis alle Spieler gerankt wurden */
    while (!bAlleSpielerGesetzt) {
    
   // log("===================WHILE-Schleife ======================");
  
      /* Initialisierung */
      bSpielerGerankt = false;
      iBestPlayerID = 1;
      
      /* Alle Spieler bercksichtigen */
      for(iPlayerID = 1; iPlayerID <= ANZAHLPLAYER; iPlayerID++) {
   //   log("=================== 1. FOR-Schleife ======================");
        /* Der nchste Spieler hat mehr Frags als der derzeitige BestPlayer bzw. bei gleicher Anzahl mehr Headshots */
        if (   (   (FragCount[iBestPlayerID] < FragCount[iPlayerID])
                || (   (FragCount[iBestPlayerID] == FragCount[iPlayerID])
                    && (HeadCount[iBestPlayerID] < HeadCount[iPlayerID])))
            && (iBestPlayerID != iPlayerID)) {
   //       log("=================== 1. IF ======================");
          /* Prfung, ob der nchste Spieler schon im Ranking steht */
          for(iPlayerRankingID = 1; iPlayerRankingID <= ANZAHLPLAYER; iPlayerRankingID++) {
   //         log("=================== 2. FOR-Schleife ======================");
            if (Ranking[iPlayerRankingID] == iPlayerID) {
   //           log("=================== 2. IF ======================");
              bSpielerGerankt = true;
            }
          }
          
          /* Spieler noch nicht im Ranking enthalten */
          if (!bSpielerGerankt) {
   //         log("=================== 3. IF ======================");
            /* Der BestPlayer wird gewechselt */
            iBestPlayerID = iPlayerID;
          }
        }
        /* BestPlayer hat mehr Frags als der nchste Spieler */ 
        else {
          if (iBestPlayerID != iPlayerID) {
   //         log("=================== 1. ELSE ======================");
            bSpielerGerankt = false;
            /* Prfung, ob der Spieler schon im Ranking steht */
            for(iPlayerRankingID = 1; iPlayerRankingID <= ANZAHLPLAYER; iPlayerRankingID++) {
   //           log("=================== 3. FOR ======================");
              /* Spieler im Ranking enthalten */
              if (Ranking[iPlayerRankingID] == iBestPlayerID) {
   //             log("=================== 4. IF ======================");
                bSpielerGerankt = true;
              }
            }
          
            /* Spieler im Ranking enthalten */ 
            if (bSpielerGerankt) {
   //           log("=================== 5. IF ======================");
              /* Der BestPlayer wird gewechselt */
              iBestPlayerID = iPlayerID;
            }
          }
    
        }
      }
      
      /* BestPlayer ins Ranking aufnehmen */
      bSpielerGerankt = false;
      for(iPlayerRankingID = 1; iPlayerRankingID <= ANZAHLPLAYER; iPlayerRankingID++) {
   //     log("=================== 4. FOR ======================");
        /* Den ersten freien Rankingplatz ermitteln */ 
        if (   (Ranking[iPlayerRankingID] == 0)
            && (!bSpielerGerankt)) {
   //       log("=================== 6. IF ======================");
          /* Spieler ranken */
          Ranking[iPlayerRankingID] = iBestPlayerID;
          bSpielerGerankt = true;
          
          /* Ermittlung der Spielernamen */
          // Get the sPlayerName, iUserId, iWONID, iTeam and iDead status of the player represented by iPlayerIndex.
          playerinfo(iBestPlayerID,BestPlayerName,MAX_NAME_LENGTH,iBestPlayerUserID,iBestPlayerWONID,iBestPlayerTeam,iBestPlayerDead);

          /* Es werden nur die Top 5 angezeigt */
          if (iAnzeigeZaehler <= iMaxAnzeige) {
            iAnzeigeZaehler++;
            /* Aufbereitung des Ausgabetextes */
            snprintf(Message,MAX_TEXT_LENGTH, "^nRank %i: %s -Kills: %i -Headshots: %i",iPlayerRankingID,BestPlayerName,FragCount[iBestPlayerID],HeadCount[iBestPlayerID]);
            strcat(Text,Message,MAX_TEXT_LENGTH);
          }
    
          /* Letzter Spieler gerankt */
          if (iPlayerRankingID == ANZAHLPLAYER) {
   //         log("=================== 7. IF AUSSTIEG WHILE======================");
            bAlleSpielerGesetzt = true;
          }
        }
      }
    
    }
    
  }
  else {
    /* Ermittlung der Spielernamen */
    // Get the sPlayerName, iUserId, iWONID, iTeam and iDead status of the player represented by iPlayerIndex.
    playerinfo(iBestPlayerID,BestPlayerName,MAX_NAME_LENGTH,iBestPlayerUserID,iBestPlayerWONID,iBestPlayerTeam,iBestPlayerDead);
    snprintf(Text,MAX_TEXT_LENGTH, "^nBest at the moment: %s -Kills: %i -Headshots: %i",BestPlayerName,FragCount[iBestPlayerID],HeadCount[iBestPlayerID]);
  }

  /* Ausgabe der Ranking Tabelle */
  centersay(Text, ANZEIGE_DAUER, 10, 255, 255);
  
  // log("=================== ENDE ======================");
}


//-------------------------------------------------------------------
//-------------------------------------------------------------------

/* Auslesen einer bestimmten Zeile anhand der Zeilennummer
 */
ermittleZeile(DateiName[] = "", HerkunftFunktion[] = "", iGesuchteZeile) {

  new Text[MAX_TEXT_LENGTH];
  new iMaxZeilen = 0;
  new iReadLine = 1;
  new bReadLine = false;
  new Ergebnis = NEIN;
  
  /* Ermittlung der Zeile */ 
    
  /* Prfung, ob die bentigte Datei vorhanden ist und gelesen werden darf */ 
  if (fileexists(DateiName) > 0) {
    /* Erstes Lesen */
    bReadLine = readfile(DateiName,GESUCHTEZEILE,iReadLine,MAX_TEXT_LENGTH);
    /* Ermittlung der Anzahl aller mglichen Zeilen */
    if (bReadLine) {
      while (bReadLine) {
        ++iMaxZeilen;
        ++iReadLine;
        bReadLine = readfile(DateiName,GESUCHTEZEILE,iReadLine,MAX_TEXT_LENGTH);
      }
      iMaxZeilen = --iMaxZeilen; // Abzglich der Zeile, die nicht mehr gelesen werden konnte
      
      /* Gesuchte Zeile ist vorhanden */
      if (iGesuchteZeile <= iMaxZeilen) {
        Ergebnis = JA;
        bReadLine = readfile(DateiName,GESUCHTEZEILE,iGesuchteZeile,MAX_TEXT_LENGTH);
      }
      else {
        Ergebnis = NEIN;
        GESUCHTEZEILE = LEER;
      }
    }
    else {
      snprintf(Text,MAX_TEXT_LENGTH,"%s >> Die Datei %s konnte nicht gelesen werden.", HerkunftFunktion, DateiName);
      log(Text);
      Ergebnis = NEIN;
      /* Prfung, ob die Leseberechtigung vorhanden ist */
      if (getvar("file_access_read") == 1) {
        snprintf(Text,MAX_TEXT_LENGTH,"%s >> In der Datei %s wurde die Leseberechtigung vergeben.", HerkunftFunktion, DateiName);
        log(Text);
      }
      /* Leseberechtigung ist nicht vorhanden */
      else {
        snprintf(Text,MAX_TEXT_LENGTH,"%s >> In der Datei %s wurde keine Leseberechtigung vergeben.", HerkunftFunktion, DateiName);
        log(Text);
      }
    }
  }
  else {
    snprintf(Text,MAX_TEXT_LENGTH,"%s >> Die Datei %s ist nicht vorhanden.", HerkunftFunktion, DateiName);
    log(Text);
    Ergebnis = NEIN;
  }
  
  return(Ergebnis);

}
  
//-------------------------------------------------------------------
//-------------------------------------------------------------------

/* Auslesen einer zuflligen Zeile
 */
ermittleZufallsZeile(DateiName[] = "", HerkunftFunktion[] = "") {

  new Text[MAX_TEXT_LENGTH];
  new iTextNummer;
  new iMaxTexte = 0;
  new bReadLine = false;
  new iReadLine = 1;
  new Ergebnis = NEIN;
    
  /* Ermittlung des Sound-Spruches */ 
    
  /* Prfung, ob die bentigte Datei vorhanden ist und gelesen werden darf */ 
  if (fileexists(DateiName) > 0) {
    /* Erstes Lesen */
    bReadLine = readfile(DateiName,ZUFALLSZEILE,iReadLine,MAX_TEXT_LENGTH);
    /* Ermittlung der Anzahl aller mglichen Texte */
    if (bReadLine) {
      while (bReadLine) {
        ++iMaxTexte;
        ++iReadLine;
        bReadLine = readfile(DateiName,ZUFALLSZEILE,iReadLine,MAX_TEXT_LENGTH);
      }
      
      iMaxTexte = --iMaxTexte; // Abzglich der Zeile, die nicht mehr gelesen werden konnte
      /* Zufllige Auswahl des Textes */
      iTextNummer = random(iMaxTexte);
      /* Lesen des ausgewhlten Textes */
      bReadLine = readfile(DateiName,ZUFALLSZEILE,iTextNummer,MAX_TEXT_LENGTH);
      Ergebnis = JA;
    }
    else {
      snprintf(Text,MAX_TEXT_LENGTH,"%s >> Die Datei %s konnte nicht gelesen werden.", HerkunftFunktion, DateiName);
      log(Text);
      Ergebnis = NEIN;
      /* Prfung, ob die Leseberechtigung vorhanden ist */
      if (getvar("file_access_read") == 1) {
        snprintf(Text,MAX_TEXT_LENGTH,"%s >> In der Datei %s wurde die Leseberechtigung vergeben.", HerkunftFunktion, DateiName);
        log(Text);
      }
      /* Leseberechtigung ist nicht vorhanden */
      else {
        snprintf(Text,MAX_TEXT_LENGTH,"%s >> In der Datei %s wurde keine Leseberechtigung vergeben.", HerkunftFunktion, DateiName);
        log(Text);
      }
    }
  }
  else {
    snprintf(Text,MAX_TEXT_LENGTH,"%s >> Die Datei %s ist nicht vorhanden.", HerkunftFunktion, DateiName);
    log(Text);
    Ergebnis = NEIN;
  }
  
  return(Ergebnis);

}

//-------------------------------------------------------------------
//-------------------------------------------------------------------

/* Auslesen der gesetzten Admin-Befehle aus der Vaultdatei
 * bzw. Initialisierung der Admin-Befehle in der Vaultdatei
 */
public vaultdata() {

  new Returnmatch[MAX_DATA_LENGTH];
  new RundenZaehler[MAX_DATA_LENGTH];
  new LastScout[MAX_DATA_LENGTH];
  new Announce[MAX_DATA_LENGTH];
  new KillStreak[MAX_DATA_LENGTH];
  new HeadShot[MAX_DATA_LENGTH];
  new BestPlayer[MAX_DATA_LENGTH];

  /* Auslesen des Parameters */
  get_vaultdata("admin_returnmatch",Returnmatch,MAX_DATA_LENGTH);
  get_vaultdata("admin_roundcount",RundenZaehler,MAX_DATA_LENGTH);
  get_vaultdata("admin_lastscout",LastScout,MAX_DATA_LENGTH);
  get_vaultdata("admin_announce",Announce,MAX_DATA_LENGTH);
  get_vaultdata("admin_killstreak",KillStreak,MAX_DATA_LENGTH);
  get_vaultdata("admin_headshot",HeadShot,MAX_DATA_LENGTH);
  get_vaultdata("admin_bestplayer",BestPlayer,MAX_DATA_LENGTH);
  
  /* Setzen der Admin-Befehle gem der Vaultdatei */
  if (Returnmatch[0] == '0') {
    bRueckrunde = false;
    return PLUGIN_HANDLED;
  }
  else {
    if (Returnmatch[0] == '1') {
      bRueckrunde = true;
      return PLUGIN_HANDLED;
    }
  }
  
  if (RundenZaehler[0] == '0') {
    bRoundCounter = false;
    return PLUGIN_HANDLED;
  }
  else {
    if (RundenZaehler[0] == '1') {
      bRoundCounter = true;
      return PLUGIN_HANDLED;
    }
  }
  
  if (LastScout[0] == '0') {
    bLastScout = false;
    return PLUGIN_HANDLED;
  }
  else {
    if (LastScout[0] == '1') {
      bLastScout = true;
      return PLUGIN_HANDLED;
    }
  }
  
  if (Announce[0] == '0') {
    bAnnounce = false;
    return PLUGIN_HANDLED;
  }
  else {
    if (Announce[0] == '1') {
      bAnnounce = true;
      return PLUGIN_HANDLED;
    }
  }	
  
  if (KillStreak[0] == '0') {
    bKillStreak = false;
    return PLUGIN_HANDLED;
  }
  else {
    if (KillStreak[0] == '1') {
      bKillStreak = true;
      return PLUGIN_HANDLED;
    }
  }	 
  
  if (HeadShot[0] == '0') {
    bHeadShot = false;
    return PLUGIN_HANDLED;
  }
  else {
    if (HeadShot[0] == '1') {
      bHeadShot = true;
      return PLUGIN_HANDLED;
    }
  }
  
  if (BestPlayer[0] == '0') {
    bBestPlayer = false;
    return PLUGIN_HANDLED;
  }
  else {
    if (BestPlayer[0] == '1') {
      bBestPlayer = true;
      return PLUGIN_HANDLED;
    }
  }	 	  			

  /* Setzen des Standard Admin-Befehlswertes, wenn nichts in der Vaultdatei
   * steht und Schreiben dieses Wertes in die Vaultdatei */
  bRueckrunde = true;
  set_vaultdata("admin_returnmatch",cRueckrundeStandard);
  selfmessage("Rueckrunde eingeschaltet (Standard).");
  selfmessage("Moegliche Werte sind:");
  selfmessage("0: Rueckrunde Aus, 1: Rueckrunde An.");
      
  bRoundCounter = true;
  set_vaultdata("admin_roundcount",cRundenZaehlerStandard);
  selfmessage("Rundenzaehler eingeschaltet (Standard).");
  selfmessage("Moegliche Werte sind:");
  selfmessage("0: Rundenzaehler Aus, 1: Rundenzaehler An.");
  
  bLastScout = true;
  set_vaultdata("admin_lastscout",cLastScoutStandard);
  selfmessage("LastScout eingeschaltet (Standard).");
  selfmessage("Moegliche Werte sind:");
  selfmessage("0: LastScout Aus, 1: LastScout An.");
  
  bAnnounce = true;
  set_vaultdata("admin_announce",cAnnounceStandard);
  selfmessage("Announce eingeschaltet (Standard).");
  selfmessage("Moegliche Werte sind:");
  selfmessage("0: Announce Aus, 1: Announce An.");
  
  bKillStreak = true;
  set_vaultdata("admin_killstreak",cKillStreakStandard);
  selfmessage("KillStreak eingeschaltet (Standard).");
  selfmessage("Moegliche Werte sind:");
  selfmessage("0: KillStreak Aus, 1: KillStreak An.");
  
  bHeadShot = true;
  set_vaultdata("admin_headshot",cHeadShotStandard);
  selfmessage("HeadShot eingeschaltet (Standard).");
  selfmessage("Moegliche Werte sind:");
  selfmessage("0: HeadShot Aus, 1: HeadShot An.");
  
  bBestPlayer = true;
  set_vaultdata("admin_bestplayer",cBestPlayerStandard);
  selfmessage("BestPlayer eingeschaltet (Standard).");
  selfmessage("Moegliche Werte sind:");
  selfmessage("0: BestPlayer Aus, 1: BestPlayer An.");
  
  return PLUGIN_HANDLED;
}


/* Diese Funktion wird durch das Connecten eines
 * Spielers aufgerufen
 */ 
public plugin_connect(HLUserName, HLIP, UserIndex) {
  
	new UserName[MAX_NAME_LENGTH];
	new IP[MAX_DATA_LENGTH];
		
	/* Auslesen des Consolen-Commandos */
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username
	convert_string(HLIP,IP,MAX_TEXT_LENGTH); // IP
	
	/* Gesamtspielerzahl erhhen */
  ANZAHLPLAYER += 1;
	
	/* Initialisierung der FragAnzahl fr killstreak */
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		KillCount[UserIndex] = CLEAN_SLATE;
	}
	
	/* Initialisierung der FragAnzahl fr headshot */
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		HeadCount[UserIndex] = CLEAN_SLATE;
	}
	
	/* Initialisierung der FragAnzahl fr bestplayer */
	if (UserIndex >= 1 && UserIndex <= MAX_PLAYERS) {
		FragCount[UserIndex] = CLEAN_SLATE;
	}
	
}   

/* Diese Funktion wird durch das DisConnecten eines
 * Spielers aufgerufen
 */ 
public plugin_disconnect(HLUserName, UserIndex) {
  
  new UserName[MAX_NAME_LENGTH];
  new Text[MAX_TEXT_LENGTH];
  new Ergebnis = NEIN;
  
  /* Auslesen des Commandos */
  convert_string(HLUserName,UserName,MAX_NAME_LENGTH); // Username
  
  /* Gesamtspielerzahl ermigen */
  ANZAHLPLAYER -= 1;
    
  /* Prfen, ob der LastScout benachrichtigt werden mu */
  Ergebnis = pruefe_LastScout();
  if (Ergebnis == JA) {
      bLastScout_Informiert = true;
  }
  
  return PLUGIN_CONTINUE;
}

/* Initialisierung des Plugins
 */
public plugin_init() {
  // Registers the plugin with the Admin mod
  // plugin_registerinfo(Name, Description, Version)
  plugin_registerinfo("[HLB]Jabberwocky's Usefull-things-Plugin","Usefull things ist eine Sammlung von ntzlichen Plugins.",STRING_VERSION);

  /* Bekanntmachung der neuen Admin-Befehle */
  // plugin_registercmd(Command, Function, RequiredAccess, HelpMessage)
  plugin_registercmd("admin_mapcycle", "admin_mapcycle", ACCESS_MAPCYCLE,"admin_mapcycle <n> Laedt die verschiedenen Mapcycle.");
  plugin_registercmd("admin_returnmatch", "admin_returnmatch", ACCESS_RUECKRUNDE, "admin_returnmatch (1/0):  0=Rueckrunde AUS, 1=Rueckrunde AN");
  plugin_registercmd("admin_roundcount", "admin_roundcount", ACCESS_ROUNDCOUNT, "admin_roundcount (1/0):  0=Roundcount AUS, 1=Roundcount AN");
  plugin_registercmd("admin_lastscout", "admin_lastscout", ACCESS_LASTSCOUT, "admin_lastscout (1/0):  0=Lastscout AUS, 1=Lastscout AN");
  plugin_registercmd("admin_announce", "admin_announce", ACCESS_ANNOUNCE, "admin_announce (1/0):  0=Announce AUS, 1=Announce AN");
  plugin_registercmd("admin_killstreak", "admin_killstreak", ACCESS_KILLSTREAK, "admin_killstreak (1/0):  0=Killsteak AUS, 1=Killstreak AN");
  plugin_registercmd("admin_headshot", "admin_headshot", ACCESS_HEADSHOT, "admin_headshot (1/0):  0=HeadShot AUS, 1=HeadShot AN");
  plugin_registercmd("admin_bestplayer", "admin_bestplayer", ACCESS_BESTPLAYER, "admin_bestplayer (1/0):  0=BestPlayer AUS, 1=BestPlayer AN");

  /* Bekannmachung der LOGD-Commandos */
  plugin_registercmd("logd_suicide", "logd_suicide", ACCESS_CONSOLE, "");
  plugin_registercmd("logd_kill", "logd_kill", ACCESS_CONSOLE, "");
  plugin_registercmd("logd_hurt", "logd_hurt", ACCESS_CONSOLE, "");
  plugin_registercmd("logd_teamaction", "logd_teamaction", ACCESS_CONSOLE, "");
  plugin_registercmd("logd_worldaction", "logd_worldaction", ACCESS_CONSOLE, "");
  plugin_registercmd("logd_teamscore", "logd_teamscore", ACCESS_CONSOLE, "");
    
  /* Ausfhrung der LOGD-Commandos */
  exec( "logd_reg 53 admin_command logd_suicide" );     // 53 Player Suicide
  exec( "logd_reg 57 admin_command logd_kill" );        // 57 Player Kill
  exec( "logd_reg 58 admin_command logd_hurt" );        // 58 Player Hurt
  exec( "logd_reg 61 admin_command logd_teamaction" );  // 61 Team Action	
  exec( "logd_reg 62 admin_command logd_worldaction" ); // 62 World Action
  exec( "logd_reg 65 admin_command logd_teamscore" );   // 65 Team Score Report
    
  /* Auslesen der gesetzten Admin-Befehle aus der Vaultdatei bzw.
   * Schreiben dieser in die Vaultdatei */
  vaultdata();

  return PLUGIN_CONTINUE;

}
